/*
*************************************************************************************
*                         			      Linux
*					           USB Host Controller Driver
*
*				        (c) Copyright 2006-2012, SoftWinners Co,Ld.
*							       All Rights Reserved
*
* File Name 	: sw_hcd_board.h
*
* Author 		: javen
*
* Description 	: 弶
*
* Notes         :
*
* History 		:
*      <author>    		<time>       	<version >    		<desc>
*       javen     	  2010-12-20           1.0          create this file
*
*************************************************************************************
*/
#ifndef  __SW_HCD_BOARD_H__
#define  __SW_HCD_BOARD_H__

#include <mach/sys_config.h>

#define  USB_SRAMC_BASE	            0x01c00000
#define  USB_CLOCK_BASE				0x01C20000
#define  USB_PIO_BASE	            0x01c20800

/* i/o Ϣ */
typedef struct sw_hcd_io{
	struct resource	*usb_base_res;   	/* USB  resources 		*/
	struct resource	*usb_base_req;   	/* USB  resources 		*/
	void __iomem	*usb_vbase;			/* USB  base address 	*/

	struct resource	*sram_base_res;   	/* SRAM resources 		*/
	struct resource	*sram_base_req;   	/* SRAM resources 		*/
	void __iomem	*sram_vbase;		/* SRAM base address 	*/

	struct resource	*clock_base_res;   	/* clock resources 		*/
	struct resource	*clock_base_req;   	/* clock resources 		*/
	void __iomem	*clock_vbase;		/* clock base address 	*/

	struct resource	*pio_base_res;   	/* pio resources 		*/
	struct resource	*pio_base_req;   	/* pio resources 		*/
	void __iomem	*pio_vbase;			/* pio base address 	*/

	bsp_usbc_t usbc;					/* usb bsp config 		*/
	__hdle usb_bsp_hdle;				/* usb bsp handle 		*/

	__u32 clk_is_open;					/* is usb clock open? 	*/
	struct clk	*sie_clk;				/* SIE clock handle 	*/
	struct clk	*phy_clk;				/* PHY gate 			*/
	struct clk	*phy0_clk;				/* PHY reset 			*/
	
	unsigned drv_vbus_valid;
	script_item_u drv_vbus_gpio_set;
	__u32 host_init_state;				/* usb ĳʼ״̬0 : . 1 :  */
	__u32 usb_enable;
}sw_hcd_io_t;

#endif   //__SW_HCD_BOARD_H__


